Type TBackground
	Field red:Int
	Field grn:Int
	Field blu:Int
	' wave image
	Field images:TImage[]
	Field notes:Int[]
	' note properties
	Field playing:Int
	Field playNote:Int, playAmount:Double
	Field playTime:Int
	
	Function Create:TBackground(pNotes:Int[])
		Local bg:TBackground = New TBackground
		bg.GenerateImage(pNotes)
		Return bg
	End Function
	
	' render images for given notes
	Method GenerateImage(pNotes:Int[])
		notes	= pNotes
		images	= New TImage[pNotes.length]
		For Local i:Int = 0 Until pNotes.length
			_GenerateImage(i, 440*2^((notes[i]-60)/12.0))
		Next
	End Method
	
	Method _GenerateImage(pImageIdx:Int, pFreq:Double)
		images[pImageIdx] = CreateImage(800,600)
		MidHandleImage(images[pImageIdx])
		Local pm:TPixmap = LockImage(images[pImageIdx])
		For Local y:Int = 0 Until 600
			For Local x:Int = 0 Until 800
				Local dx:Double = 400-x
				Local dy:Double = 300-y
				Local dist:Double = Sqr(dx*dx+dy*dy)
				Local f:Double = 1
				Local gr:Int = 255
				' waves
				f :* Max(Min(1,(0.5 +Sin((dist *pFreq /220.0) /20.0 *360))),0)
				' darken out
				f :* Max((1 -dist /400:Double), 0)
				gr :* f
				gr=Max(Min(255,gr),0)
				WritePixel(pm, x,y, (255 Shl 24)|(gr Shl 16)|(gr Shl 8)|gr)
			Next
		Next
		UnlockImage(images[pImageIdx])
	End Method
	
	Method Draw()
		' don't draw if no note is beeing played
		If Not playing Then Return
		' brightness factor (depending on time and note volume)
		Local a:Double = 0.1 +Exp(-(TDemo.playTime -playTime)/1000.0)*0.9
		a :* playAmount /127:Double
		' scale factor for motion (depending on note play time)
		Local scale:Double = 1.1 +0.1*Sin((TDemo.playTime -playTime)/1000.0*360)
		' find image for note
		Local i:Int = 0
		For Local n:Int = 0 Until notes.length
			If notes[n] = playNote
				i = n
				Exit
			EndIf
		Next
		' draw waves
		SetScale scale,scale
		SetRotation 0
		SetColor red*a, grn*a, blu*a
		SetBlend LIGHTBLEND
		DrawImage images[i], 400,300
	End Method
	
	Method Play(pNote:Int, pAmount:Double)
		playing = True
		playNote		= pNote
		playAmount	= pAmount
		playTime		= TDemo.playTime
	End Method
	Method Stop()
		playing = False
	End Method
End Type

